# DetachDisks

## 1. API Description

This API (DetachDisks) is used to detach one or more disks from an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Disks to be detached should be attached to the same instance. If any of the disks is undetachable, the operation will not be performed.</mark>
* <mark style="color:blue;">Only operations on disks with the status of</mark> <mark style="color:blue;">**IN\_use**</mark> <mark style="color:blue;">are supported.</mark>
* <mark style="color:blue;">Only operations on disks that are detachable (</mark><mark style="color:blue;">**`portable`**</mark><mark style="color:blue;">**&#x20;**</mark><mark style="color:blue;">**=**</mark><mark style="color:blue;">**&#x20;**</mark><mark style="color:blue;">**`true`**</mark><mark style="color:blue;">) are supported.</mark>
* <mark style="color:blue;">Operation on boot disks are not supported.</mark>
* <mark style="color:blue;">A maximum of 10 disks can be detached from an instance in one request.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name    | Required | Type            | Description                                                                                                                                              |
| ----------------- | -------- | --------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------- |
| diskIds           | Yes      | Array of String | ID list of disks to be detached.                                                                                                                         |
| instanceCheckFlag | No       | Boolean         | <p>Check instance running status.</p><p>Default value: true , meaning disk detach allowed only when instance is shut down.</p><p>Default value: true</p> |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| failedDiskIds  | Array of String | Disks failed to be detached.                                                                                          |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Detach one or more disks from an instance.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DetachDisks
<Common Request Params>

Request:
{
  "diskIds": [
    "your-disk-id"
  ]
}

Response:
{
  "requestId": "T86A56634-582A-4615-BBE2-ABFE192EE7CE",
  "response": {
    "requestId": "T86A56634-582A-4615-BBE2-ABFE192EE7CE",
    "failedDiskIds": []
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                               | Description                                                   |
| ---------------- | ---------------------------------------- | ------------------------------------------------------------- |
| 404              | INVALID\_DISK\_NOT\_FOUND                | Disk does not exist.                                          |
| 400              | INVALID\_DISK\_NOT\_PORTABLE             | Disk is not detachable.                                       |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND            | Instance not found.                                           |
| 400              | OPERATION\_DENIED\_DISK\_SYSTEM\_TYPE    | The operation is not supported for system disks.              |
| 400              | UNSUPPORTED\_OPERATION\_DISK\_NO\_ATTACH | Disk is not attached to any instance.                         |
| 400              | UNSUPPORTED\_OPERATION\_DISK\_STATUS     | Operations on the disk with current status are not supported. |
| 400              | UNSUPPORTED\_OPERATION\_INSTANCE\_STATUS | Operations on instances in current state are not supported.   |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/zec/disk/detachdisks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
